VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Tile tutorial"
   ClientHeight    =   6315
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5565
   LinkTopic       =   "Form1"
   ScaleHeight     =   421
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   371
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdRandomMove 
      Caption         =   "Random destinations"
      Height          =   435
      Left            =   2100
      TabIndex        =   3
      Top             =   5700
      Width           =   1755
   End
   Begin VB.CommandButton cmdAddUnits 
      Caption         =   "Add units"
      Height          =   435
      Left            =   3960
      TabIndex        =   2
      Top             =   5700
      Width           =   1215
   End
   Begin VB.PictureBox Front 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   4860
      Left            =   300
      ScaleHeight     =   320
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   320
      TabIndex        =   0
      Top             =   660
      Width           =   4860
   End
   Begin VB.Label lblInfo 
      Caption         =   "Use left button to move your unit, right button to drag camera"
      Height          =   315
      Index           =   0
      Left            =   300
      TabIndex        =   1
      Top             =   240
      Width           =   4875
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Used for camera movement
    Dim X2 As Long
    Dim Y2 As Long
Public Sub Main()
    Me.Show
    
    'This is the "main loop"
    While DoEvents
        'Update scene
        mUnits.UpdateUnits
        
        'Update animations
        mTiles.Animate
        mUnits.Animate
        
        'Update display
        Redraw
    Wend
End Sub

Public Sub Redraw()
    'Draw
    mMap.DrawFloor
    mMap.DrawUnits
    mMap.DrawRoof
    
    'Update ("flip") display
    Front.Refresh
End Sub

Private Sub cmdAddUnits_Click()
    Dim A As Long
    
    For A = 0 To 4
        'Create unit
        AddUnit "player.gif", 23, 35, 6, 100, 1
        
        'Set random position and speed
        MoveUnit UnitCount, CLng(Map.W * TileSize * Rnd), CLng(Map.H * TileSize * Rnd)
        Unit(UnitCount).Direction = CLng(3 * Rnd)
    Next
End Sub

Private Sub cmdRandomMove_Click()
    mUnits.MoveRandomly
End Sub

Private Sub Form_Load()
    'Setup
    Randomize
    SourcePath = App.Path & "\SOURCE\"
    
    'Initialize modules
    mBitmap.Initialize frmMain
    mMap.Reset
    mTiles.Reset
    mCamera.Reset frmMain.Front
    
    'Load map and resources
    mMap.LoadData App.Path & "\Test.map"
    mTiles.LoadResources
    
    'Add demo units
    AddUnit "player.gif", 23, 35, 6, 100, 1
    MoveUnit UnitCount, 8 * TileSize, 10 * TileSize
    Unit(UnitCount).Direction = 2
    cmdAddUnits_Click
    
    'Run game
    Main
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'Release modules
    mTiles.Reset
    mMap.Reset
    mBitmap.Reset
End Sub

Private Sub Front_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Select Case Button
    Case 1 'Left button
        Dim Destination As tCoord2D
        
        'Setup target position
        Destination.X = CLng((X - (TileSize / 2) + Camera.X) / TileSize)
        Destination.Y = CLng((Y - (TileSize / 2) + Camera.Y) / TileSize)
        
        'Create waypoints
        FindPath 1, Destination

    Case 2 'Right button
        X2 = CLng(X)
        Y2 = CLng(Y)
    End Select
End Sub
Private Sub Front_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Select Case Button
    Case 1: 'Left button
    
    Case 2: 'Right button
        'Drag camera
        mCamera.LookAt Camera.X + CLng(X) - X2, Camera.Y + CLng(Y) - Y2
        
        'Store new cursor position
        X2 = X
        Y2 = Y
    End Select
End Sub

